# Test cases for Lab 6 - Fall 2023
#-------------------------------------------------------------------------------------------
import autotester_base
from autotester_base import Lit, opts

def testall(start=None, mode='brief', clear=True):
   autotester_base.test_target_list(_target_list, _test_cases, start, mode, clear)

def test(fun_or_name, cases=None, mode=None, alias=None, input=None):
   autotester_base.test_single_function(fun_or_name, cases, mode, alias, input, _test_cases)

def vtest(fun_or_name, cases=None, alias=None, input=None):
   autotester_base.test_single_function(fun_or_name, cases, 'verbose', alias, input, _test_cases)

#-------------------------------------------------------------------------------------------

_target_list = [
   'choose', 'addup', 'mean', 'squares', 'standardDev', 'flip', 'palindrome'
   ]

#-------------------------------------------------------------------------------------------

_test_cases = {

   'choose':{
      1: ('', (10, 5), 252),
      2: ('', (7, 7), 1),
      3: ('', (3, 0), 1),
      4: ('', (3, 1), 3),
      5: ('', (7, 2), 21),
      6: ('', (8, 3), 56),
      },
   'addup':{
      1: ('', ([10],), 10),
      2: ('', ([1,2,3,4,5],), 15),
      3: ('', ([],), 0),
      4: ('', (range(10),), 45),
      5: ('', ([-1, 1, -1, -1, 2],), 0),
      },
   'mean':{
      1: ('', ([1,1,2,3],), 1.75),
      2: ('', ([5,5,5],), 5),
      3: ('', (range(10),), 4.5),
      4: ('', ([0],), 0),
      5: ('', ([7,7,7,7,7,7,7,16],), 8.125),
      },
   'squares':{
      1: ('', ([10],), [100]),
      2: ('', ([1,2,3,4],), [1, 4, 9, 16]),
      3: ('', ([2.5,3,3.5],), [6.25, 9, 12.25]),
      4: ('', ([],), []),
      5: ('', (range(10),), [0, 1, 4, 9, 16, 25, 36, 49, 64, 81]),
      },
   'standardDev':{
      1: ('', ([1,2,3],), 1.0),
      2: ('', ([5,5],), 0),
      3: ('', ([1,3],), 1.4142135623730951),
      4: ('', ([1,2,3,4],), 1.2909944487358056),
      5: ('', ([-3,7,9,-2,0,7,1,-4],), 5.0832357523811265),
      },
   'flip':{
      1: ('', ('apple',), 'elppa'),
      2: ('', ('level',), 'level'),
      3: ('', ('watermelon',), 'nolemretaw'),
      4: ('', ('',), ''),
      5: ('', ('lever',), 'revel'),
      },
   'palindrome':{
      1: ('', ('apple',), 'no'),
      2: ('', ('level',), 'yes'),
      3: ('', ('watermelon',), 'no',),
      4: ('', ('',), 'yes'),
      5: ('', ('lever',), 'no'),
      6: ('', ('racecar',), 'yes'),
      },

   }
